Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/Properties/AssemblyInfo.cs.frame	(revision 12773)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/Properties/AssemblyInfo.cs.frame	(revision 12776)
@@ -27,6 +27,6 @@
 // set of attributes. Change these attribute values to modify the information
 // associated with an assembly.
-[assembly: AssemblyTitle("HeuristicLab.Services.WebApp")]
-[assembly: AssemblyDescription("HeuristicLab Services Application Container")]
+[assembly: AssemblyTitle("HeuristicLab.Services.WebApp.Statistics")]
+[assembly: AssemblyDescription("HeuristicLab WebApp Statistics plugin")]
 [assembly: AssemblyConfiguration("")]
 [assembly: AssemblyCompany("")]
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs	(revision 12773)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs	(revision 12776)
@@ -83,5 +83,5 @@
                     UsedMemory = offline ? 0 : clientInfo.UsedMemory,
                     CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
-                    State = clientInfo.SlaveState.ToString(),
+                    State = offline ? SlaveState.Offline.ToString() : clientInfo.SlaveState.ToString(),
                     LastUpdate = clientInfo.Time,
                     GroupId = client.ResourceGroupId,
@@ -132,5 +132,5 @@
                          UsedMemory = offline ? 0 : clientInfo.UsedMemory,
                          CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
-                         State = clientInfo.SlaveState.ToString(),
+                         State = offline ? SlaveState.Offline.ToString() : clientInfo.SlaveState.ToString(),
                          GroupId = client.ResourceGroupId,
                          GroupName = client.GroupName,
@@ -218,5 +218,5 @@
                          UsedMemory = offline ? 0 : clientInfo.UsedMemory,
                          CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
-                         State = clientInfo.SlaveState.ToString(),
+                         State = offline ? SlaveState.Offline.ToString() : clientInfo.SlaveState.ToString(),
                          GroupId = client.ResourceGroupId,
                          GroupName = client.GroupName,
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientTaskDetailsDialog.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientTaskDetailsDialog.cshtml	(revision 12773)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientTaskDetailsDialog.cshtml	(revision 12776)
@@ -5,8 +5,8 @@
     <h4 class="modal-title">Task #{{taskNo}} - {{task.Id}}</h4>
 </div>
-<div class="modal-body" style="height: 430px">
+<div class="modal-body" style="height: 440px">
     <tabset>
         <tab heading="Details">
-            <div style="height: 330px" class="center-block">
+            <div style="height: 340px" class="center-block">
                 <div class="row" style="padding-top: 30px">
                     <div class="col-md-6">
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/details/jobTaskDetailsDialog.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/details/jobTaskDetailsDialog.cshtml	(revision 12773)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/details/jobTaskDetailsDialog.cshtml	(revision 12776)
@@ -3,8 +3,8 @@
     <h4 class="modal-title">Task #{{taskNo}} - {{task.Id}}</h4>
 </div>
-<div class="modal-body" style="height: 430px">
+<div class="modal-body" style="height: 440px">
     <tabset>
         <tab heading="Details">
-            <div style="height: 330px" class="center-block">
+            <div style="height: 340px" class="center-block">
                 <div class="row" style="padding-top: 30px">
                     <div class="col-md-12">