Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetails.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetails.cshtml	(revision 12776)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetails.cshtml	(revision 12778)
@@ -195,8 +195,21 @@
             <label for="fromDate">To:&nbsp;</label>
             <div class="input-group">
-                <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="toDate" is-open="toIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close" />
+                <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="toDate" is-open="toIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close"/>
                 <span class="input-group-btn">
                     <button type="button" class="btn btn-default" ng-click="openToDateSelection($event)"><i class="glyphicon glyphicon-calendar"></i></button>
                 </span>
+            </div>
+        </div>
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <div class="btn-group" dropdown dropdown-append-to-body>
+                <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle style="width: 130px; text-align: left;">
+                    <span class="text-left" style="display: inline-block; width: 85px;">{{curQuickSelection.name}}</span>
+                    <span class="glyphicon glyphicon-chevron-down" style="margin-top: 3px;"></span>
+                </button>
+                <ul class="dropdown-menu" role="menu">
+                    <li ng-repeat="quickSelection in quickSelectionList">
+                        <a class="cursor-pointer" ng-click="changeQuickSelection(quickSelection)">{{quickSelection.name}}</a>
+                    </li>
+                </ul>
             </div>
         </div>
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetailsCtrl.js
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetailsCtrl.js	(revision 12776)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetailsCtrl.js	(revision 12778)
@@ -171,4 +171,37 @@
             $scope.toIsOpen = false;
 
+            $scope.quickSelectionList = [
+                { id: 0, name: 'Custom' },
+                { id: 1, name: 'Today' },
+                { id: 2, name: 'Yesterday' },
+                { id: 3, name: 'Last 7 Days' },
+                { id: 4, name: 'Last 30 Days' }
+            ];
+            $scope.changeQuickSelection = function (quickSelection) {
+                var today = new Date();
+                var oneDayInMs = 24 * 60 * 60 * 1000;
+                switch (quickSelection.id) {
+                    case 1:
+                        $scope.fromDate = new Date(today.valueOf());
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 2:
+                        $scope.fromDate = new Date(today.valueOf() - oneDayInMs);
+                        $scope.toDate = new Date(today.valueOf() - oneDayInMs);
+                        break;
+                    case 3:
+                        $scope.fromDate = new Date(today.valueOf() - (7 * oneDayInMs));
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 4:
+                        $scope.fromDate = new Date(today.valueOf() - (30 * oneDayInMs));
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                }
+                $scope.curQuickSelection = quickSelection;
+            };
+            // set default 'today'
+            $scope.changeQuickSelection($scope.quickSelectionList[1]);
+
             $scope.openFromDateSelection = function ($event) {
                 $event.preventDefault();
@@ -176,4 +209,5 @@
                 $scope.toIsOpen = false;
                 $scope.fromIsOpen = true;
+                $scope.curQuickSelection = $scope.quickSelectionList[0];
             };
 
@@ -183,4 +217,5 @@
                 $scope.fromIsOpen = false;
                 $scope.toIsOpen = true;
+                $scope.curQuickSelection = $scope.quickSelectionList[0];
             };
 
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/exceptions/exceptions.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/exceptions/exceptions.cshtml	(revision 12776)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/exceptions/exceptions.cshtml	(revision 12778)
@@ -36,5 +36,5 @@
                             <th>Job</th>
                             <th>Task</th>
-                            <th>User</th>
+                            <th>Username</th>
                             <th>Client</th>
                             <th>Date</th>
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetails.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetails.cshtml	(revision 12776)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetails.cshtml	(revision 12778)
@@ -224,8 +224,21 @@
              <label for="fromDate">To:&nbsp;</label>
              <div class="input-group">
-                 <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="toDate" is-open="toIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close" />
+                 <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="toDate" is-open="toIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close"/>
                  <span class="input-group-btn">
                      <button type="button" class="btn btn-default" ng-click="openToDateSelection($event)"><i class="glyphicon glyphicon-calendar"></i></button>
                  </span>
+             </div>
+         </div>
+         <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+             <div class="btn-group" dropdown dropdown-append-to-body>
+                 <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle style="width: 130px; text-align: left;">
+                     <span class="text-left" style="display: inline-block; width: 85px;">{{curQuickSelection.name}}</span>
+                     <span class="glyphicon glyphicon-chevron-down" style="margin-top: 3px;"></span>
+                 </button>
+                 <ul class="dropdown-menu" role="menu">
+                     <li ng-repeat="quickSelection in quickSelectionList">
+                         <a class="cursor-pointer" ng-click="changeQuickSelection(quickSelection)">{{quickSelection.name}}</a>
+                     </li>
+                 </ul>
              </div>
          </div>
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetailsCtrl.js
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetailsCtrl.js	(revision 12776)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetailsCtrl.js	(revision 12778)
@@ -104,4 +104,37 @@
             $scope.toIsOpen = false;
 
+            $scope.quickSelectionList = [
+                { id: 0, name: 'Custom' },
+                { id: 1, name: 'Today' },
+                { id: 2, name: 'Yesterday' },
+                { id: 3, name: 'Last 7 Days' },
+                { id: 4, name: 'Last 30 Days' }
+            ];
+            $scope.changeQuickSelection = function (quickSelection) {
+                var today = new Date();
+                var oneDayInMs = 24 * 60 * 60 * 1000;
+                switch (quickSelection.id) {
+                    case 1:
+                        $scope.fromDate = new Date(today.valueOf());
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 2:
+                        $scope.fromDate = new Date(today.valueOf() - oneDayInMs);
+                        $scope.toDate = new Date(today.valueOf() - oneDayInMs);
+                        break;
+                    case 3:
+                        $scope.fromDate = new Date(today.valueOf() - (7 * oneDayInMs));
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 4:
+                        $scope.fromDate = new Date(today.valueOf() - (30 * oneDayInMs));
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                }
+                $scope.curQuickSelection = quickSelection;
+            };
+            // set default 'today'
+            $scope.changeQuickSelection($scope.quickSelectionList[1]);
+
             $scope.openFromDateSelection = function ($event) {
                 $event.preventDefault();
@@ -109,4 +142,5 @@
                 $scope.toIsOpen = false;
                 $scope.fromIsOpen = true;
+                $scope.curQuickSelection = $scope.quickSelectionList[0];
             };
 
@@ -116,4 +150,5 @@
                 $scope.fromIsOpen = false;
                 $scope.toIsOpen = true;
+                $scope.curQuickSelection = $scope.quickSelectionList[0];
             };
 
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobs.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobs.cshtml	(revision 12776)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/jobs/jobs.cshtml	(revision 12778)
@@ -39,5 +39,5 @@
                             <th>Job Name</th>
                             @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
-                                <th>User Name</th>
+                                <th>Username</th>
                             }
                             <th>Date Created</th>