Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 12778)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 12780)
@@ -86,4 +86,5 @@
                                 <th>#</th>
                                 <th>Client Name</th>
+                                <th>Group Name</th>
                                 <th>Cores</th>
                                 <th>Cpu Utilization</th>
@@ -96,4 +97,8 @@
                             <td>{{($index + 1)+((curExpiredClientsPage-1)*(expiredClientsPageSize))}}</td>
                             <td>{{client.Name}}</td>
+                            <td>
+                                <span ng-show="client.GroupName">{{client.GroupName}}</span>
+                                <span ng-hide="client.GroupName">No Group</span>
+                            </td>
                             <td>{{client.UsedCores}} / {{client.TotalCores}}</td>
                             <td>{{client.CpuUtilization | number: 2}} %</td>
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetails.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetails.cshtml	(revision 12778)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetails.cshtml	(revision 12780)
@@ -203,6 +203,6 @@
         <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
             <div class="btn-group" dropdown dropdown-append-to-body>
-                <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle style="width: 130px; text-align: left;">
-                    <span class="text-left" style="display: inline-block; width: 85px;">{{curQuickSelection.name}}</span>
+                <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle style="width: 145px; text-align: left;">
+                    <span class="text-left" style="display: inline-block; width: 100px;">{{curQuickSelection.name}}</span>
                     <span class="glyphicon glyphicon-chevron-down" style="margin-top: 3px;"></span>
                 </button>
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetailsCtrl.js
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetailsCtrl.js	(revision 12778)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetailsCtrl.js	(revision 12780)
@@ -176,5 +176,7 @@
                 { id: 2, name: 'Yesterday' },
                 { id: 3, name: 'Last 7 Days' },
-                { id: 4, name: 'Last 30 Days' }
+                { id: 4, name: 'Last 30 Days' },
+                { id: 5, name: 'Last 6 Months' },
+                { id: 6, name: 'Last Year' }
             ];
             $scope.changeQuickSelection = function (quickSelection) {
@@ -196,4 +198,18 @@
                     case 4:
                         $scope.fromDate = new Date(today.valueOf() - (30 * oneDayInMs));
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 5:
+                        var month = today.getMonth() - 6;
+                        if (month < 0) {
+                            month += 12;
+                        }
+                        $scope.fromDate = new Date(today.valueOf());
+                        $scope.fromDate.setMonth(month);
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 6:
+                        $scope.fromDate = new Date(today.valueOf());
+                        $scope.fromDate.setFullYear(today.getFullYear() - 1);
                         $scope.toDate = new Date(today.valueOf());
                         break;
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetails.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetails.cshtml	(revision 12778)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetails.cshtml	(revision 12780)
@@ -232,6 +232,6 @@
          <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
              <div class="btn-group" dropdown dropdown-append-to-body>
-                 <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle style="width: 130px; text-align: left;">
-                     <span class="text-left" style="display: inline-block; width: 85px;">{{curQuickSelection.name}}</span>
+                 <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle style="width: 145px; text-align: left;">
+                     <span class="text-left" style="display: inline-block; width: 100px;">{{curQuickSelection.name}}</span>
                      <span class="glyphicon glyphicon-chevron-down" style="margin-top: 3px;"></span>
                  </button>
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetailsCtrl.js
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetailsCtrl.js	(revision 12778)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/groups/details/groupDetailsCtrl.js	(revision 12780)
@@ -109,5 +109,7 @@
                 { id: 2, name: 'Yesterday' },
                 { id: 3, name: 'Last 7 Days' },
-                { id: 4, name: 'Last 30 Days' }
+                { id: 4, name: 'Last 30 Days' },
+                { id: 5, name: 'Last 6 Months' },
+                { id: 6, name: 'Last Year' }
             ];
             $scope.changeQuickSelection = function (quickSelection) {
@@ -129,4 +131,18 @@
                     case 4:
                         $scope.fromDate = new Date(today.valueOf() - (30 * oneDayInMs));
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 5:
+                        var month = today.getMonth() - 6;
+                        if (month < 0) {
+                            month += 12;
+                        }
+                        $scope.fromDate = new Date(today.valueOf());
+                        $scope.fromDate.setMonth(month);
+                        $scope.toDate = new Date(today.valueOf());
+                        break;
+                    case 6:
+                        $scope.fromDate = new Date(today.valueOf());
+                        $scope.fromDate.setFullYear(today.getFullYear() - 1);
                         $scope.toDate = new Date(today.valueOf());
                         break;