Index: branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/ViewModel/EvaluationViewModel.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/ViewModel/EvaluationViewModel.cs	(revision 12762)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/ViewModel/EvaluationViewModel.cs	(revision 12781)
@@ -1,4 +1,3 @@
-﻿using System.Collections.ObjectModel;
-using HeuristicLab.Algorithms.Bandits.BanditPolicies;
+﻿using HeuristicLab.Algorithms.Bandits.BanditPolicies;
 using HeuristicLab.Algorithms.GeneticProgramming;
 using HeuristicLab.Algorithms.GrammaticalOptimization;
@@ -7,9 +6,7 @@
 using System;
 using System.Collections.Generic;
+using System.Collections.ObjectModel;
 using System.ComponentModel;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Problems.GrammaticalOptimization.SymbReg;
 
 namespace Evaluation.ViewModel
@@ -85,40 +82,4 @@
         }
 
-        private double bestKnownQuality;
-
-        public double BestKnownQuality
-        {
-            get { return this.bestKnownQuality; }
-            set
-            {
-                this.bestKnownQuality = value;
-                this.OnPropertyChanged("BestKnownQuality");
-            }
-        }
-
-        private double currentBestQuality;
-
-        public double CurrentBestQuality
-        {
-            get { return this.currentBestQuality; }
-            set
-            {
-                this.currentBestQuality = value;
-                this.OnPropertyChanged("CurrentBestQuality");
-            }
-        }
-
-        private int evaluations;
-
-        public int Evaluations
-        {
-            get { return this.evaluations; }
-            set
-            {
-                this.evaluations = value;
-                this.OnPropertyChanged("Evaluations");
-            }
-        }
-
         private int nrRuns;
 
@@ -129,12 +90,4 @@
         }
 
-        private int threads;
-
-        public int Threads
-        {
-            get { return this.threads; }
-            set { this.threads = value; this.OnPropertyChanged("Threads"); }
-        }
-
         private int maxLen;
 
@@ -193,52 +146,4 @@
         }
 
-        private string currentRunString;
-
-        public string CurrentRunString
-        {
-            get { return this.currentRunString; }
-            set
-            {
-                currentRunString = value;
-                this.OnPropertyChanged("CurrentRunString");
-            }
-        }
-
-        private double evaluationsPerSec;
-
-        public double EvaluationsPerSec
-        {
-            get { return this.evaluationsPerSec; }
-            set
-            {
-                evaluationsPerSec = value;
-                this.OnPropertyChanged("EvaluationsPerSec");
-            }
-        }
-
-        private int bestSolutionFoundAt;
-
-        public int BestSolutionFoundAt
-        {
-            get { return this.bestSolutionFoundAt; }
-            set
-            {
-                bestSolutionFoundAt = value;
-                this.OnPropertyChanged("BestSolutionFoundAt");
-            }
-        }
-
-        private string bestSolution;
-
-        public string BestSolution
-        {
-            get { return this.bestSolution; }
-            set
-            {
-                bestSolution = value;
-                this.OnPropertyChanged("BestSolution");
-            }
-        }
-
         private ObservableCollection<Run> runs = new ObservableCollection<Run>();
 
@@ -253,20 +158,25 @@
         }
 
-        private Run currentRun;
-
-        public Run CurrentRun
-        {
-            get { return this.currentRun; }
-            set
-            {
-                currentRun = value;
-                if (currentRun != null)
-                {
-                    Evaluations = currentRun.Evaluations;
-                    BestKnownQuality = currentRun.BestKnownQuality;
-                    CurrentBestQuality = currentRun.BestSolutionQuality;
-                    EvaluationsPerSec = currentRun.EvaluationsPerSecond;
-                }
-                this.OnPropertyChanged("CurrentRun");
+        private Run selectedRun;
+
+        public Run SelectedRun
+        {
+            get { return this.selectedRun; }
+            set
+            {
+                selectedRun = value;
+                this.OnPropertyChanged("SelectedRun");
+            }
+        }
+
+        private string completedRuns;
+
+        public string CompletedRuns
+        {
+            get { return this.completedRuns; }
+            set
+            {
+                completedRuns = value;
+                this.OnPropertyChanged("CompletedRuns");
             }
         }
@@ -305,8 +215,9 @@
             this.algorithms.Add(typeof(SequentialSearch));
             this.algorithms.Add(typeof(MonteCarloTreeSearch));
+            this.algorithms.Add(typeof(MonteCarloTreeSearch_PruneLeaves));
             this.algorithms.Add(typeof(StandardGP));
             this.algorithms.Add(typeof(OffspringSelectionGP));
 
-            this.selectedAlgorithm = typeof(MonteCarloTreeSearch);
+            this.selectedAlgorithm = typeof(MonteCarloTreeSearch_PruneLeaves);
         }
 