Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessModel.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessModel.cs	(revision 12791)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/GaussianProcessModel.cs	(revision 12792)
@@ -168,5 +168,5 @@
       alglib.densesolverreport denseSolveRep;
 
-      var res = alglib.trfac.spdmatrixcholesky(ref l, n, false);
+      var res = alglib.spdmatrixcholesky(ref l, n, false);
       if (!res) throw new ArgumentException("Matrix is not positive semidefinite");
 
@@ -297,5 +297,5 @@
 
       // for stddev 
-      alglib.ablas.rmatrixlefttrsm(n, newN, l, 0, 0, false, false, 0, sWKs, 0, 0);
+      alglib.rmatrixlefttrsm(n, newN, l, 0, 0, false, false, 0, ref sWKs, 0, 0);
 
       for (int i = 0; i < newN; i++) {
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs	(revision 12791)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs	(revision 12792)
@@ -47,4 +47,5 @@
     private LinearRegression(LinearRegression original, Cloner cloner)
       : base(original, cloner) {
+
     }
     public LinearRegression()
@@ -77,9 +78,9 @@
         throw new NotSupportedException("Linear regression does not support NaN or infinity values in the input dataset.");
 
-      alglib.linearmodel lm = new alglib.linearmodel();
-      alglib.lrreport ar = new alglib.lrreport();
+      alglib.linearmodel lm;
+      alglib.lrreport ar;
       int nRows = inputMatrix.GetLength(0);
       int nFeatures = inputMatrix.GetLength(1) - 1;
-      double[] coefficients = new double[nFeatures + 1]; // last coefficient is for the constant
+      double[] coefficients;
 
       int retVal = 1;
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/MultinomialLogitClassification.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/MultinomialLogitClassification.cs	(revision 12791)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/MultinomialLogitClassification.cs	(revision 12792)
@@ -74,6 +74,6 @@
         throw new NotSupportedException("Multinomial logit classification does not support NaN or infinity values in the input dataset.");
 
-      alglib.logitmodel lm = new alglib.logitmodel();
-      alglib.mnlreport rep = new alglib.mnlreport();
+      alglib.logitmodel lm;
+      alglib.mnlreport rep;
       int nRows = inputMatrix.GetLength(0);
       int nFeatures = inputMatrix.GetLength(1) - 1;
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/TimeSeries/AutoregressiveModeling.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/TimeSeries/AutoregressiveModeling.cs	(revision 12791)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/TimeSeries/AutoregressiveModeling.cs	(revision 12792)
@@ -100,6 +100,6 @@
 
 
-      alglib.linearmodel lm = new alglib.linearmodel();
-      alglib.lrreport ar = new alglib.lrreport();
+      alglib.linearmodel lm;
+      alglib.lrreport ar;
       int nRows = inputMatrix.GetLength(0);
       int nFeatures = inputMatrix.GetLength(1) - 1;
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/RunCollectionVariableImpactView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/RunCollectionVariableImpactView.cs	(revision 12791)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/RunCollectionVariableImpactView.cs	(revision 12792)
@@ -276,5 +276,5 @@
           }
           // wilcoxon signed rank test is used because the impact values of two variables in a single run are not independent
-          alglib.wsr.wilcoxonsignedranktest(z, z.Length, 0, ref bothTails, ref leftTail, ref rightTail);
+          alglib.wilcoxonsignedranktest(z, z.Length, 0, out bothTails, out leftTail, out rightTail);
           matrix[row, numberOfRuns + 3] = Math.Round(bothTails, 4);
         }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/AutoCorrelationCalculator.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/AutoCorrelationCalculator.cs	(revision 12791)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/AutoCorrelationCalculator.cs	(revision 12792)
@@ -31,6 +31,6 @@
       }
 
-      double[] correlations = new double[values.Length];
-      alglib.corr.corrr1dcircular(values, values.Length, values, values.Length, ref correlations);
+      double[] correlations;
+      alglib.corrr1dcircular(values, values.Length, values, values.Length, out correlations);
       return correlations;
     }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/DependencyCalculator/SpearmansRankCorrelationCoefficientCalculator.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/DependencyCalculator/SpearmansRankCorrelationCoefficientCalculator.cs	(revision 12791)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/DependencyCalculator/SpearmansRankCorrelationCoefficientCalculator.cs	(revision 12792)
@@ -41,5 +41,5 @@
         var original = originalValues.ToArray();
         var estimated = estimatedValues.ToArray();
-        rs = alglib.basestat.spearmancorr2(original, estimated, original.Length);
+        rs = alglib.spearmancorr2(original, estimated, original.Length);
         errorState = OnlineCalculatorError.None;
       }